.386
.MODEL flat, stdcall
OPTION CASEMAP:NONE   ;Case sensitive

uselib	MACRO	libname
	include		libname.inc
	includelib	libname.lib
ENDM

Include windows.inc
Include \masm32\macros\macros.asm

uselib kernel32
;uselib user32
uselib pdh
uselib masm32
uselib msvcrt

; Prototypes -------------------------------------------

Main				   PROTO
InitPdhCounter    	   PROTO

; Constants --------------------------------------------

PDH_MAX_COUNTER_PATH   EQU 0800h
PDH_FMT_LONG           EQU 0100h
PDH_CSTATUS_VALID_DATA EQU 0h	; The returned data is valid.

; Structures -------------------------------------------

CPULoad Struct
    hQuery             HANDLE ?
    hCounter           HANDLE ?
    uElapse            DWORD ?
    TimerID            DWORD ?
    dwValue            DWORD ?
CPULoad EndS

PDH_COUNTER_PATH_ELEMENTS STRUCT
	szMachineName      DWORD ?     ; optional - Pointer to a null-terminated string that specifies the computer name.
	szObjectName       DWORD ?     ; required - Pointer to a null-terminated string that specifies the object name.
	szInstanceName     DWORD ?     ; optional - Pointer to a null-terminated string that specifies the instance name.
	szParentInstance   DWORD ?     ; optional - Pointer to a null-terminated string that specifies the parent instance name.
	dwInstanceIndex    DWORD ?     ; optional - Index of duplicate instance names.
	szCounterName      DWORD ?     ; required - to a null-terminated string that specifies the counter name.
	szFillBytes        BYTE PDH_MAX_COUNTER_PATH DUP (?)
PDH_COUNTER_PATH_ELEMENTS ENDS

PDH_FMT_COUNTERVALUE STRUCT
    CStatus            DWORD ?
    unionPadding       DWORD ?
    longValue          DWORD ?
    extraBytes         DWORD ?
PDH_FMT_COUNTERVALUE ENDS

;-------------------------------------------------------

.DATA
cpl         CPULoad <0,0,0,0,0>
szInstName 	DB "0",0       ; PDH instance name
szInstName1	DB "_Total",0  ; PDH instance name, use alternate
CRLF        DB 0AH,0DH,0


